#include <stdlib.h>
#include <stdio.h>

size_t filelen;
void *loadfile(char *name) {
  void *mem = NULL; FILE *fd;
  if ((fd = fopen(name, "rb"))) {
    if ((fseek(fd, 0, SEEK_END) == 0) && (filelen = ftell(fd))
    &&  (fseek(fd, 0, SEEK_SET) == 0) && (mem = malloc(filelen))) {
      if (fread(mem, 1, filelen, fd) < filelen) { free(mem); mem = NULL; }
    }
    fclose(fd);
  }
  return mem;
}

void ppsimilar(unsigned char *k, size_t klen, unsigned char *u, size_t ulen) {
  unsigned int kstart, ustart, x1, x2;
  unsigned char ubits = u[ulen-1], kbits = k[klen-1];

  if (u[0]!='P' || u[1]!='X' || u[2]!='2' || u[3]!='0') {
    printf("The first file must be an encrypted powerpacker file\n");
    return;
  }

  if (k[0]!='P' || k[1]!='P' || k[2]!='2' || k[3]!='0') {
    printf("The second file must be an unencrypted powerpacker file\n");
    return;
  }

  if (k[4]!=u[6] || k[5]!=u[7] || k[6]!=u[8] || k[7]!=u[9]) {
    char *list[] = {"Fast","Mediocre","Good","Very Good","Best","Unknown"};
    int x = ((u[9] < 9) || (u[9] > 13)) ? 5 : u[9] - 9;
    printf("The two files must have the same compression mode\n");
    printf("The encrypted file is packed with Efficiency=%s\n", list[x]);
    return;
  }

  if (kbits > 31) {
    printf("Unencrypted file is broken!\n");
    return;
  }

  if (ubits > 31) {
    printf("Encrypted file is broken!\n");
    return;
  }

  x1 = (k[klen-12]<<24) | (k[klen-11]<<16) | (k[klen-10]<<8) | k[klen-9];
  x2 = (k[klen-8]<<24)  |  (k[klen-7]<<16) | (k[klen-6] <<8) | k[klen-5];
  kstart = (kbits == 0) ? x2 : ((x1<<(32-kbits))|(x2>>kbits));

  x1 = (u[ulen-12]<<24) | (u[ulen-11]<<16) | (u[ulen-10]<<8) | u[ulen-9];
  x2 = (u[ulen-8]<<24)  |  (u[ulen-7]<<16) | (u[ulen-6] <<8) | u[ulen-5];
  ustart = (ubits == 0) ? x2 : ((x1<<(32-ubits))|(x2>>ubits));

  printf("Unencrypted file stream starts with 0x%08x.\n", kstart);
  printf("Encrypted file stream starts with 0x%08x.\n", ustart);

  ustart ^= kstart;
  ustart = (ustart << ubits) | (ustart >> (32 - ubits));

  printf("Therefore, if encrypted stream matched unencrypted stream after\n");
  printf("decryption, the decryption key would be 0x%08x.\n\n", ustart);
}

int main(int argc, char *argv[]) {
  void *known, *unknown;
  size_t known_len, unknown_len;
  
  if (argc != 3) {
    printf("Usage: %s <encrypted file> <similar unencrypted file>\n", argv[0]);
    printf("Example: %sunknown.amos.pp known.amos.pp\n", argv[0]);
    return 1;
  }

  unknown = loadfile(argv[1]);
  unknown_len = filelen;

  known = loadfile(argv[2]);
  known_len = filelen;

  if ((unknown != NULL) && (known != NULL)) {
    ppsimilar((unsigned char *)known,   known_len,
	      (unsigned char *)unknown, unknown_len);
  }
  free(known);
  free(unknown);
  return 0;
}
